% simple back reaction AKT --(rictor)--> AKT
% add feedback on rictor raptor --(AKT)--> rictor
% add other reaction of AKTp
% add raptor activation

function bistability ()


clear all; close all;clc;
AKT_total=100;
mTOR_total=100;

%% Define AKTp

AKT=100;
AKT__=AKT;

%% Define pAKT

pAKT = 0;
pAKT__ = pAKT;

%% Define AKTp

AKTp=0;
AKTp__=AKTp;

%% Define pAKTp

pAKTp = 0;
pAKTp__ = pAKTp;

% AKTp_vector=1:AKT_total;
% pAKTp_vector=AKT_total-AKTp_vector;


%% define rictor

rictor = 0;
rictor__=rictor; 


%% define mTOR_raptor

raptor =  mTOR_total-rictor;
raptor__= raptor;

%% define PP2A

PP2A = 150;
PP2A__=PP2A;
MM_PP2A_pAKT=0.10;MM_PP2A_AKTp=0.10;
alpha_PP2A_pAKT=4;alpha_PP2A_AKTp=1;

%% define PTEN

PTEN=200;
MM_PTEN_AKTp=0.25;
alpha_PTEN_AKTp=1;

%% define PDK1
PDK1_total=100;
PDK1p=50;
PDK1p__=PDK1p;

PDK1=PDK1_total-PDK1p;
PDK1__=PDK1;

MM_PDK1p_AKT = 10;
alpha_PDK1p_AKT =20;

MM_raptor_PDK1p =10;
alpha_raptor_PDK1p =10;

beta_PDK1_2_PDK1p=5;

% rictor_vector = 1:(mTOR_total/100):mTOR_total;

MM_rictor_AKT = 5;
alpha_rictor_AKT =20;

MM_pAKT_rictor = 10;
alpha_pAKT_rictor=10;

beta_raptor_2_rictor =1;



%% Load the variables to start the simulation from a selected situation

%load bistability_variables_initial_path_inactive
%load bistability_variables_initial_path_active


%% ---------------------temporal scaling-----------------%%%
time_in_min=.1;% [min]
time_in_sec = time_in_min * 60;% [sec]
time_step = 50.6154e-05;
iterations=time_in_sec/time_step;

refresh=50; % when the plot is drawn


for ii=1:iterations
    
    rictor = rictor__ + time_step * (...
            - MM_interaction (MM_pAKT_rictor,alpha_pAKT_rictor,pAKTp__,rictor__) ...  rictor 2 raptor
            + beta_raptor_2_rictor * raptor__...  raptor 2 rictor
            );       
    
    pAKT = pAKT__ +  time_step * (...
               + MM_interaction(MM_rictor_AKT,alpha_rictor_AKT,rictor__,AKT__) ... pAKT 2 AKT
               - MM_interaction(MM_PP2A_pAKT,alpha_PP2A_pAKT,PP2A__,pAKT__) ... % pAKT 2 AKT
               - MM_interaction(MM_PDK1p_AKT,alpha_PDK1p_AKT,PDK1p__,pAKT__) ... pAKT 2 pAKTp by PDK1
               + MM_interaction(MM_PP2A_AKTp,alpha_PP2A_AKTp,PP2A__,pAKTp__) ... % pAKTp 2 pAKT
               + MM_interaction(MM_PTEN_AKTp,alpha_PTEN_AKTp,PTEN,pAKTp__)... PTEN pAKTp 2 pAKT
            );  
        
    AKTp = AKTp__ +  time_step * (...
               + MM_interaction(MM_PDK1p_AKT,alpha_PDK1p_AKT,PDK1p__,AKT__) ... AKT 2 AKTp by PDK1
               - MM_interaction(MM_PP2A_AKTp,alpha_PP2A_AKTp,PP2A__,AKTp__) ... % pAKT 2 AKT
               - MM_interaction(MM_rictor_AKT,alpha_rictor_AKT,rictor__,AKTp__) ... AKTp 2 pAKTp
               + MM_interaction(MM_PP2A_AKTp,alpha_PP2A_AKTp,PP2A__,pAKTp__) ... % pAKTp 2 AKTp
               - MM_interaction(MM_PTEN_AKTp,alpha_PTEN_AKTp,PTEN,AKTp__)... PTEN pAKT 2 AKT
            );
        
    AKT = AKT__ +  time_step * (...
               - MM_interaction(MM_PDK1p_AKT,alpha_PDK1p_AKT,PDK1p__,AKT__) ... AKT 2 AKTp by PDK1
               + MM_interaction(MM_PP2A_pAKT,alpha_PP2A_pAKT,PP2A__,pAKT__) ... % pAKT 2 AKT
               - MM_interaction(MM_rictor_AKT,alpha_rictor_AKT,rictor__,AKT__) ... AKT 2 pAKT
               + MM_interaction(MM_PP2A_AKTp,alpha_PP2A_AKTp,PP2A__,AKTp__) ... % pAKT 2 AKT
               + MM_interaction(MM_PTEN_AKTp,alpha_PTEN_AKTp,PTEN,AKTp__)... PTEN pAKT 2 AKT
            );
        
      
    pAKTp = pAKTp__ + time_step * (...
            + MM_interaction(MM_PDK1p_AKT,alpha_PDK1p_AKT,PDK1p__,pAKT__) ... pAKT 2 pAKTp by PDK1
            + MM_interaction(MM_rictor_AKT,alpha_rictor_AKT,rictor__,AKTp__) ... AKTp 2 pAKTp
            - MM_interaction(MM_PP2A_AKTp,alpha_PP2A_AKTp,PP2A__,pAKTp__) ... % pAKTp 2 AKTp
            - MM_interaction(MM_PP2A_AKTp,alpha_PP2A_AKTp,PP2A__,pAKTp__) ... % pAKTp 2 pAKT
            - MM_interaction(MM_PTEN_AKTp,alpha_PTEN_AKTp,PTEN,pAKTp__)... PTEN pAKTp 2 pAKT
          ); 
            

    PDK1p = PDK1p__ + time_step * (...
            - MM_interaction(MM_raptor_PDK1p,alpha_raptor_PDK1p,raptor__,PDK1p__)...
            + beta_PDK1_2_PDK1p * PDK1__...
          );
        
        
        AKTp__ = AKTp;
        pAKT__= pAKT;
        pAKTp__= pAKTp;
        AKT__ = AKT;
        PDK1p__=PDK1p;
        PDK1__ = PDK1_total-PDK1p__;
        
        
%         AKTp__ = AKTp;
%         pAKTpp__ = pAKTp;
        
        rictor__ = rictor;
        raptor__ =  mTOR_total-rictor__;
        
    
  if rem(ii,refresh) == 0;
         
      figure(1);subplot(1,2,1);

hold on;plot(ii,pAKTp,'.r');plot(ii,AKTp__,'.g');plot(ii,pAKT__,'.b');plot(ii,AKT__,'.k');legend('pAKTp','AKTp','pAKT','AKT');axis([0 ii 0 100])

      figure(1);subplot(1,2,2);

hold on;plot(ii,rictor,'.r');plot(ii,raptor__,'.k');legend('rictor','raptor');axis([0 ii 0 100])


xlabel('Time [a.u.]','Fontsize',14);
ylabel('Conc. [nM]','Fontsize',14); 
time_on= (ii*time_step);title(time_on);

    
        
     end
     
end

%% to save the variables in the simulations uncomment the following line

%save bistability_variables_initial_path_inactive
%save bistability_variables_initial_path_active


function product = MM_interaction (MM,alpha,enzyme,substrate)

product = enzyme * substrate  * alpha ./(MM + substrate);

function result = mass_action_reaction (reactant_1,reactant_2,product,alpha,beta)

result = alpha * reactant_1 * reactant_2 - beta * product;




